VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form frmTreeSample 
   Caption         =   "Form1"
   ClientHeight    =   5775
   ClientLeft      =   60
   ClientTop       =   285
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   5775
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox Picture1 
      Height          =   2175
      Left            =   1350
      ScaleHeight     =   2115
      ScaleWidth      =   1755
      TabIndex        =   1
      Top             =   3390
      Width           =   1815
      Begin VB.CommandButton Command5 
         Caption         =   "Change Image"
         Height          =   435
         Left            =   0
         TabIndex        =   6
         Top             =   1680
         Width           =   1755
      End
      Begin VB.CommandButton Command1 
         Caption         =   "Make Tree"
         Height          =   375
         Left            =   0
         TabIndex        =   5
         Top             =   0
         Width           =   1755
      End
      Begin VB.CommandButton Command2 
         Caption         =   "Stats for this Node"
         Height          =   405
         Left            =   0
         TabIndex        =   4
         Top             =   390
         Width           =   1755
      End
      Begin VB.CommandButton Command3 
         Caption         =   "My Siblings Are"
         Height          =   405
         Left            =   0
         TabIndex        =   3
         Top             =   810
         Width           =   1755
      End
      Begin VB.CommandButton Command4 
         Caption         =   "My Children Are"
         Height          =   435
         Left            =   0
         TabIndex        =   2
         Top             =   1230
         Width           =   1755
      End
   End
   Begin MSComctlLib.ImageList ImageList1 
      Left            =   3900
      Top             =   3300
      _ExtentX        =   1005
      _ExtentY        =   1005
      BackColor       =   -2147483643
      ImageWidth      =   16
      ImageHeight     =   16
      MaskColor       =   12632256
      _Version        =   393216
      BeginProperty Images {2C247F25-8591-11D1-B16A-00C0F0283628} 
         NumListImages   =   3
         BeginProperty ListImage1 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "frmTreeSample.frx":0000
            Key             =   ""
         EndProperty
         BeginProperty ListImage2 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "frmTreeSample.frx":1DBC
            Key             =   ""
         EndProperty
         BeginProperty ListImage3 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "frmTreeSample.frx":3B44
            Key             =   ""
         EndProperty
      EndProperty
   End
   Begin MSComctlLib.TreeView TreeView1 
      Height          =   2955
      Left            =   60
      TabIndex        =   0
      Top             =   210
      Width           =   4425
      _ExtentX        =   7805
      _ExtentY        =   5212
      _Version        =   393217
      Indentation     =   529
      Style           =   7
      ImageList       =   "ImageList1"
      Appearance      =   1
   End
End
Attribute VB_Name = "frmTreeSample"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'*************************************************************************************
' In searching the internet for treeview sample code I soon discovered that there was very little
' available so I decided that after I was finished with my application I would write this sample
' application for the sole purpose of preventing this frustration for others. It isn't exactly
' perfect (coding standards and all) but the basic functionality that you will need to build, maneuver
' through and retrieve data from a treeview is represented here. Have fun, I hope it helps.
'*************************************************************************************

'*****************************************************************************
'Building a tree is pretty basic. I have set up this particular tree in a retail company type
'of format.
'*****************************************************************************
Private Sub Command1_Click()
Dim nodX As Node
Dim I As Integer
Dim J As Integer
Dim K As Integer
Dim L As Integer

TreeView1.Nodes.Clear
'  Corporate Office
Set nodX = TreeView1.Nodes.Add(, , "R", "Corporate Office", 1)

'  Regional Level
For I = 1 To 20
  Set nodX = TreeView1.Nodes.Add("R", tvwChild, "R" & Trim$(Str$(I)), "Region " & Trim$(Str$(I)), 1)
Next
nodX.EnsureVisible   ' Make sure all nodes are visible.

'  District Level
J = 1
For I = 1 To 20
  L = J + 4
  K = J
  For J = K To L
       Set nodX = TreeView1.Nodes.Add("R" & Trim$(Str$(I)), tvwChild, "D" & Trim$(Str$(J)), "District " & Trim$(Str$(J)), 1)
  Next
Next

'  Store Level
J = 1
For I = 1 To 100
       L = J + 9
       K = J
       For J = K To L
            Set nodX = TreeView1.Nodes.Add("D" & Trim$(Str$(I)), tvwChild, "S" & Trim$(Str$(J)), "Store# " & Trim$(Str$(J)), 1)
       Next
Next
   
End Sub

'*****************************************************************************
'This sub is intended to show how you can identify the node you are on with it's text and
'how to retrieve information about the node, it's parents, siblings or children
'*****************************************************************************
Private Sub Command2_Click()
Dim NumOfSibs As Integer
Dim NumOfStores As Integer
Dim Idx As Integer
On Error GoTo ErrStat

If InStr(1, TreeView1.SelectedItem, "Store") Then 'give store info
     NumOfSibs = TreeView1.SelectedItem.Parent.Children
     MsgBox TreeView1.SelectedItem & " has " & Trim$(Str$(NumOfSibs - 1)) & " siblings" 'minus one for the one we are on
ElseIf InStr(1, TreeView1.SelectedItem, "District") Then 'give district info
     NumOfSibs = TreeView1.SelectedItem.Children
     MsgBox TreeView1.SelectedItem & " has " & Trim$(Str$(NumOfSibs)) & " Stores"
ElseIf InStr(1, TreeView1.SelectedItem, "Region") Then 'give regional info
     NumOfSibs = TreeView1.SelectedItem.Children
     For Idx = TreeView1.SelectedItem.Child.FirstSibling.Index To TreeView1.SelectedItem.Child.LastSibling.Index
          NumOfStores = NumOfStores + TreeView1.Nodes.Item(Idx).Children
     Next
     MsgBox TreeView1.SelectedItem & " has " & Trim$(Str$(NumOfSibs)) & " Districts" & vbCr & _
                  "And " & NumOfStores & " Stores"
End If
TreeView1.SetFocus

Exit Sub
ErrStat:
If Err.Number = 91 Then MsgBox "A Node has not been selected"
End Sub

'*****************************************************************************
'This sub is intended to show how you can maneuver through the tree at a sibling level
'to gather information
'*****************************************************************************
Private Sub Command3_Click()
Dim Idx As Integer
On Error GoTo ErrStat

For Idx = TreeView1.SelectedItem.FirstSibling.Index To TreeView1.SelectedItem.LastSibling.Index
     MsgBox TreeView1.Nodes.Item(Idx).Text
Next
TreeView1.SetFocus

Exit Sub
ErrStat:
If Err.Number = 91 Then MsgBox "A Node has not been selected"
End Sub

'*****************************************************************************
'This sub is intended to show how you can maneuver through the tree at a child level
'to gather information
'*****************************************************************************
Private Sub Command4_Click()
Dim Idx As Integer
On Error GoTo ErrStat

For Idx = TreeView1.SelectedItem.Child.FirstSibling.Index To TreeView1.SelectedItem.Child.LastSibling.Index
     MsgBox TreeView1.Nodes.Item(Idx).Text
Next
TreeView1.SetFocus

Exit Sub
ErrStat:
If Err.Number = 91 And InStr(1, TreeView1.SelectedItem, "Store") Then
     MsgBox TreeView1.SelectedItem & " Has no children"
ElseIf Err.Number = 91 Then
     MsgBox "A Node has not been selected"
End If
End Sub

'*****************************************************************************
'This sub is intended to show how simple it is to set images for nodes. You could use the
'code in Command4_Click(), slightly altered, to change the images of all children
'*****************************************************************************
Private Sub Command5_Click()
Dim Img As Integer
On Error GoTo ErrStat

Img = TreeView1.SelectedItem.Image + 1
If Img > 3 Then Img = 1
TreeView1.SelectedItem.Image = Img
TreeView1.SetFocus

Exit Sub
ErrStat:
If Err.Number = 91 Then MsgBox "A Node has not been selected"
End Sub
